using System;
using System.IO;			// for StreamReader I/O from a file
using System.Windows.Forms;	// for RichTextBox
using System.Globalization;


namespace MyNamespace
{
	/// <summary>
	///		Calc part of CrypF, a data encryption system, Forms version
	///		from my XICalc - Extra Precision Integer Calculator
	///		Developed in TURBO Pascal 5.5 and 6.0, converted to Visual Basic 6
	///		and now in Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class Calc
	{
		public Calc(int dummy)     // constructor logic
		{
			Global.programURL = "http://www.geocities.com/hjsmithh/Cryp/";
			new Calc();
		}

		public Calc()	// constructor logic
		// initialize Multi-precision Named signed Integer package
		// input: nMax muDMax
		{
			Common.quiet = true;
			new MultiID();				// initialize class MultiID
			Common.delim = ";=/:()@\"";	// @ needed for Batch commands ;=/:()@"
			MultiID.debug = false;
			MultiID.diagOn = false;
			MultiID.timeIt = false;
			Common.echoB = true;
			Common.prSt = "";
			Common.oldField = "";
			Common.noChange = false;
			nL = Environment.NewLine;
			cFCIn = "";
			cFLOut = "";
			new Common();		// initialize class Common
			new Cryp();			// initialize class Cryp
			Common.running = true;
			Common.quiet = false;
			CalReadCode("AutoExec.CFC");
			Common.quiet = true;
		} // Calc

		public static void ChkResSav(int resSav, string fName)
		// check for Restore, Save, or Run procedure
		{
			if (resSav == 1) // restore
			{
				CalReadConfig();
				Common.RestoreHist();
			}
			else if (resSav == 2) // save
			{
				CalWriteConfig();
				Common.SaveHist();
			}
			else if (resSav == 3) // run
			{
				CalReadCode(fName);
			}
		}

		public static bool GetFName(ref string st)
		// get file name from command line
		// if first parm ends in .CFC, it is changed to Run("... .CFC")
		// if first parm ends in .XIN, it is changed to ReadN("... .XIN")
		{
			bool bGetFName = false;
			int i = st.Length;
			if (i > 4)
			{
				string ext = st.Substring(i - 4, 4);
				ext = ext.ToUpper();
				if (ext == ".CFC")
				{
					st = "Run(\"" + st + "\")";
					bGetFName = true;
				}
				else if (ext == ".XIN")
				{
					st = "ReadN(\"" + st + "\")";
					bGetFName = true;
				}
			}
			if (!bGetFName) st = "";
			return bGetFName;
		}

		public static void CalLFile(ref string fName) // establish log file name
		{
			if (fName == "") fName = cFLOut;
			if (fName == "") fName = "NoName.CFL";
			Common.FixFName(ref fName, "CFL");
		}

		public static void CalFileNm(string stNm, ref string st, ref string nI)
		// get File name from command line in st and put it on the list in nI
		{
			nI = Common.FileNm(ref st);
			if (!Common.quiet)
			{
				MultiID.WriteDLn(stNm + ": " + nI);
			}
		}

		public static void CalReadConfig() // read and execute file Config.CFC and Save.CFC
		{
			CalReadCode("Config.CFC");
			Cryp.restore = true;
			CalReadCode("Save.CFC");
			Cryp.restore = false;
		}

		public static void CalWriteConfig() // write file Config.CFC and Save.CFC
		{
			StreamWriter outF; // text file: configuration output
			string st;
			string savDir = Environment.CurrentDirectory.ToString();
			Directory.SetCurrentDirectory(Common.homeDir);
			Cryp.Save();
			if (Common.ChkWrite(out outF, "Config.CFC", ""))
			{
				MultiID.WriteLn(null, outF, "@Echo Off");
				MultiID.WriteLn(null, outF, "Rem  Start of file Config.CFC");
				MultiID.WriteLn(null, outF, "SetC(" + Common.mComs + ")");
				if (MultiID.diagOn) { st = "1"; } else { st = "0"; };
				if (MultiID.debug) st = "-1";
				MultiID.WriteLn(null, outF, "Diag(" + st + ")");
				if (MultiID.timeIt && !MultiID.diagOn)
					MultiID.WriteLn(null, outF, "Time");
				MultiID.WriteLn(null, outF, "ChDir(\"" + savDir + "\")");
				if (cFCIn != "")
					MultiID.WriteLn(null, outF, "CFCIn(\"" + cFCIn + "\")");
				if (cFLOut != "")
					MultiID.WriteLn(null, outF, "CFLOut(\"" + cFLOut + "\")");
				if (MultiID.logg) { st = "1"; } else { st = "0"; }
				MultiID.WriteLn(null, outF, "LogScreen(" + st + ")");
				if (Common.quiet) { st = "1"; } else { st = "0"; }
				MultiID.WriteLn(null, outF, "Quiet(" + st + ")");
				MultiID.WriteLn(null, outF, "Pri(" + Common.pri + ")");
				MultiID.WriteLn(null, outF, "Rem  End of file Config.CFC");
				if (Common.echoB) { st = "On"; } else { st = "Off"; }
				MultiID.WriteLn(null, outF, "Echo " + st);
				outF.Close();
				if (!Common.quiet) MultiID.WriteLn("File \"Config.CFC\" closed");
			}
			Directory.SetCurrentDirectory(savDir);
		} // CalWriteConfig

		public static bool AProcedure(ref string st, ref int resSav, ref string fName) // do a procedure
		{
			int po;
			int tot;
			string stL;
			int tI;         // temp for the 1st argument of a procedure
			string name = Common.GetField(ref st);
			int i = name.Length;
			resSav = 0;
			fName = "";
			if (i == 0 || MultiID.muErr) return false;
			if (st.Length > i && st[i] == '=') return false; // if name= assignment
			if (name != "CFCIN" &&
				name != "CFLOUT" &&
				name != "CHDIR" &&
				name != "CLEARHIST" &&
				name != "CL" &&
				name != "CLEARLOG" &&
				name != "DE" &&
				name != "DECODE" &&
				name != "DIAG" &&
				name != "ECHOSCREEN" &&	// same as LogScreen
				name != "EN" &&
				name != "ENCODE" &&
				name != "EQ" &&
				name != "EQ12" &&
				name != "EQUAL" &&
				name != "EQUAL12" &&
				name != "EX" &&
				name != "EXECUTE" &&
				name != "EXIT" &&
				name != "HE" &&
				name != "HELP" &&
				name != "HELPH" &&
				name != "HELPW" &&
				name != "HISTH" &&
				name != "HISTW" &&
				name != "IC" &&
				name != "IN" &&
				name != "INIT" &&
				name != "INITC" &&
				name != "KEYF" &&
				name != "KF" &&
				name != "LF" &&
				name != "LT" &&
				name != "LOGSCREEN" &&	// "PAUSE" is in batch processing
				name != "PRI" &&
				name != "QF" &&
				name != "QT" &&
				name != "QUIET" &&
				name != "RE" &&
				name != "RESTORE" &&
				name != "RUN" &&
				name != "RUNH" &&
				name != "RUNW" &&
				name != "SA" &&
				name != "SAVE" &&
				name != "SETC" &&
				name != "ST" &&
				name != "STATE" &&
				name != "TIME" &&
				name != "WRITE" &&
				name != "WRITELN")
			{
				return false;
			}
			Common.DelNPBls(ref st, i);		// if name never uses ()
			if (name == "CLEARHIST" ||
				name == "CL" ||
				name == "CLEARLOG" ||
				name == "DE" ||
				name == "DECODE" ||
				name == "EN" ||
				name == "ENCODE" ||
				name == "EQ" ||
				name == "EQ12" ||
				name == "EQUAL" ||
				name == "EQUAL12" ||
				name == "EX" ||
				name == "EXECUTE" ||
				name == "EXIT" ||
				name == "HE" ||
				name == "HELP" ||
				name == "IC" ||
				name == "IN" ||
				name == "INIT" ||
				name == "INITC" ||
				name == "KEYF" ||
				name == "KF" ||
				name == "LF" ||
				name == "LT" ||
				name == "RE" ||
				name == "RESTORE" ||
				name == "SA" ||
				name == "QF" ||
				name == "QT" ||
				name == "SAVE" ||
				name == "ST" ||
				name == "STATE" ||
				name == "TIME")
			{
				if (st != "" && st[0] == '(') // allow use of ( or () but not (x)
				{
					Common.DelNPBls(ref st, 1);
					if (st != "" && st[0] == ')') Common.DelNPBls(ref st, 1);
				}
			}
			if (name == "CLEARHIST")
			{
				Common.ClearHist();
				return true;
			}
			if (name == "CL" || name == "CLEARLOG")
			{
				Common.ClearLog();
				return true;
			}
			if (name == "DE" || name == "DECODE")
			{
				Cryp.Decode();
				return true;
			}
			if (name == "EN" || name == "ENCODE")
			{
				Cryp.Encode();
				return true;
			}
			if (name == "EQ" || name == "EQUAL")
			{
				Cryp.Equal(Cryp.fileC, Cryp.fileD);
				return true;
			}
			if (name == "EQ12" || name == "EQUAL12")
			{
				Cryp.Equal(Cryp.file1, Cryp.file2);
				return true;
			}
			if (name == "EX" || name == "EXECUTE")
			{
				Calc.CalReadCode(Cryp.fileX);
				return true;
			}
			if (name == "EXIT")	// totally quit and exit the program
			{
				MultiID.muAbort = true;
				Common.tQuitReq = true;
				Common.tExitFlag = true;
				return true;
			}
			if (name == "HE" || name == "HELP")
			{
				RunForm.HelpForm();
				return true;
			}
			if (name == "IN" || name == "INIT")
			{
				RunForm.ClearOutput();
				new Calc();             // re-initialize class Calc
				return true;
			}
			if (name == "IC" || name == "INITC")
			{
				Cryp.InitC();
				return true;
			}
			if (name == "KF" || name == "KEYF")
			{
				Cryp.GetKeyF();
				return true;
			}
			if (name == "RE" || name == "RESTORE")
			{
				resSav = 1;
				return true;
			}
			if (name == "SA" || name == "SAVE")
			{
				resSav = 2;
				return true;
			}
			if (name == "ST" || name == "STATE")
			{
				Cryp.State();
				return true;
			}
			if ((name == "CFCIN") || (name == "CFLOUT") || (name == "CHDIR") ||
				 (name == "RUN") )
			{
				if (st != "" && st[0] == '(')
				{
					Common.DelNPBls(ref st, 1);
					if (st != "" && st[0] == ')')
						Common.DelNPBls(ref st, 1);
					else if (st != "" && st[0] != '\"')
					{
						if (name == "CHDIR")
							Common.ReportSin("Directory name expected: " + name + "(|", ref st);
						else
							Common.ReportSin("File name expected: " + name + "(|", ref st);
						return true;
					}
					else
					{
						if (name == "CHDIR") Common.ChangeDir(ref st);
						if (name == "CFCIN") CalFileNm("CFCIn", ref st, ref cFCIn);
						if (name == "CFLOUT") CalFileNm("CFLOut", ref st, ref cFLOut);
						if (name == "RUN")
						{
							fName = Common.FileNm(ref st);
							resSav = 3;
						}
						Common.DelNPBls(ref st, 1);
						if (st != "" && st[0] == ')') Common.DelNPBls(ref st, 1);
						return true;
					}
				}
				if (Common.comI == null || Common.comI == "") stL = "\"";
				else stL = "\"" + Common.comI + "\"";
				if (name == "CHDIR") Common.ChangeDir(ref stL);
				if (name == "CFCIN") CalFileNm("CFCIn", ref stL, ref cFCIn);
				if (name == "CFLOUT") CalFileNm("CFLOut", ref stL, ref cFLOut);
				if (name == "RUN")
				{
					fName = Common.FileNm(ref stL);
					resSav = 3;
				}
				return true;
			}
			if (name != "WRITE" && name != "WRITELN")
			{
				if (st == "" || st[0] != '(')
				{
					if (name == "DIAG")
					{
						if (!MultiID.timeIt) Common.DoubleSpace();
						MultiID.debug = false;
						MultiID.diagOn = true;
						MultiID.timeIt = true;
					}
					else if (name == "LF")
						Cryp.LogF();
					else if (name == "LT")
						Cryp.LogT();
					else if (name == "TIME")
					{
						if (!MultiID.timeIt) Common.DoubleSpace();
						MultiID.debug = false;
						MultiID.diagOn = false;
						MultiID.timeIt = true;
					}
					else if (name == "PRI")
						Common.DisplayPriority(); // display priority status
					else if (name == "QF")
						Cryp.QuietF();
					else if (name == "QT")
						Cryp.QuietT();
					else if (name == "QUIET")
						Common.quiet = true;
					else
						Common.ReportSin("( expected: " + name + "|", ref st);
					return true;
				}
				else
				{
					Common.DelNPBls(ref st, 1);
					int n;
					tI = ToInt(st, out n);
					Common.DelNPBls(ref st, n);
					if (st != "" && st[0] == ')') Common.DelNPBls(ref st, 1);
					if (name == "DIAG")
					{
						if ((tI != 0) && !MultiID.timeIt) Common.DoubleSpace();
						MultiID.diagOn = (tI != 0);
						MultiID.debug = (tI < 0);
						MultiID.timeIt = MultiID.diagOn;
					}
					else if (name == "HELPH")
					{
						Global.objRunForm.SetHelpHeight(tI);
					}
					else if (name == "HELPW")
					{
						Global.objRunForm.SetHelpWidth(tI);
					}
					else if (name == "HISTH")
					{
						Global.objRunForm.SetHistHeight(tI);
					}
					else if (name == "HISTW")
					{
						Global.objRunForm.SetHistWidth(tI);
					}
					else if (name == "LOGSCREEN" || name == "ECHOSCREEN")
					{
						if (MultiID.logg == (tI == 0))
							Common.ToggleLogg();
					}
					else if (name == "PRI")
					{
						Common.SetPriority(tI);
						Common.DisplayPriority();
					}
					else if (name == "QUIET")
						Common.quiet = (tI != 0);
					else if (name == "RUNH")
					{
						Global.objRunForm.SetRunHeight(tI);
					}
					else if (name == "RUNW")
					{
						Global.objRunForm.SetRunWidth(tI);
					}
					else if (name == "SETC")
					{
						Common.ReSizeHist(tI);
					}
					return true;
				}
			}
			if (st != "" && st[0] == '(') // process Write and WriteLn
			{
				Common.DelNPBls(ref st, 1);
				if (st != "")
				{
					tot = 0;
					if (st != "" && st[0] == ')')
						Common.DelNPBls(ref st, 1);
					else if (st != "" && st[0] == '\"')
					{
						po = st.IndexOf("\"", 1);
						if (po < 0) po = st.Length;
						MultiID.WriteT(st.Substring(1, po - 1), ref tot);
						Common.DelNPBls(ref st, po+1);	// 1 too many ok for DelNPBls
					}
					if (st != "" && st[0] == ')') Common.DelNPBls(ref st, 1);
				}
			}
			if (name == "WRITELN") MultiID.WriteLn();
			return true;
		} // AProcedure

		public static bool Assignment(ref string st)
		// do an assignment, nI unchanged if not an assignment
		{
			string name = Common.GetField(ref st);
			int iL = name.Length;
			if (iL == 0 || st.Length < iL + 2) return false;
			if (st[iL] == '=')
			{
				string param;
				string stL = st;
				Common.DelNPBls(ref st, iL + 1);			// delete the = sign
				if (name == "KEY")
				{
					param = st;
					st = "";
				}
				else
				{
					param = Common.GetField(ref st);			// param in upper case
					param = Common.field;						// param in original case
					Common.DelNPBls(ref st, param.Length);		// delete the param
					if (param == "")
					{
						param = Common.FileNm(ref st);
						if (st != "" && st[0] == '\"') Common.DelNPBls(ref st, 1);
					}
				}
				if (param == "")
				{
					st = stL;
					return false;
				}
				Cryp.param = param;
				if (name == "CHDIR" || name == "CD")
					Cryp.ChangeDir();
				else if (name == "FILE1" || name == "F1")
					Cryp.File1();
				else if (name == "FILE2" || name == "F2")
					Cryp.File2();
				else if (name == "FILEC" || name == "FC")
					Cryp.FileC();
				else if (name == "FILED" || name == "FD")
					Cryp.FileD();
				else if (name == "FILEE" || name == "FE")
					Cryp.FileE();
				else if (name == "FILEK" || name == "FK")
					Cryp.FileK();
				else if (name == "FILEL" || name == "FL")
					Cryp.FileL();
				else if (name == "FILEX" || name == "FX")
					Cryp.FileX();
				else if (name == "KEY")
					Cryp.GetKey();
				else if (name == "LOG")
					Cryp.Log();
				else if (name == "QUIET")
					Cryp.Quiet();
				else
				{
					st = stL;
					return false;
				}
				return true;
			}
			return false;
		} // Assignment

		public static void CalReadCode(string fName) // read in a Cal code file and Run it
		{
			if (fName == "" && cFCIn != "")
				fName = cFCIn;
			if (fName == "" && Common.comI != "")
				fName = Common.comI;
			if (fName == "") fName = "NoName.CFC";
			Common.FixFName(ref fName, "CFC");
			if (!Common.RunFile(fName))
			{
				if (Common.MakeReady() == DialogResult.OK)			// pause for operator to make file/drive ready
				{
					if (!Common.RunFile(fName))
						MultiID.WriteLn("Aborting file input...");
				}
				MultiID.WriteLn();
			}
		}

		public static void CalComment(ref string st) // get Comment from command line in st
		{
			CalFileNm("File", ref st, ref Common.comI);
		}

		public static bool Primitive(ref string st, int nI) // do operation
		{
			if (MultiID.muErr) return false;
			string op = st.Substring(0, 1).ToUpper();	// operation code character "+", "S", etc.
			if (op == " " || op == ";")					// " " and ";" never get this far
				{} // noOp
			else if (op == "H")
				Common.ToggleLogg();
			else if (op == "J")
				CalReadCode("");
			else if (op == "Q")
			{
				MultiID.muAbort = true;
				Common.tQuitReq = true;
			}
			else if (op == "\"")
				CalComment(ref st);
			else if (op == "$")
			{
				RunForm.ClearOutput();
				new Calc();				// re-initialize class Calc
			}
			else if (op == ">")
				CalWriteConfig();
			else if (op == "<")
			{
				st = "";
				CalReadConfig();
			}
			else if (op == "]")
				Common.SaveHist();
			else if (op == "[")
				Common.RestoreHist();
			else if (op == "?")
				RunForm.HelpForm();
			else
			{
				return false;
			}
			Common.DelNPBls(ref st, 1);
			return true;
		} // Primitive

		public static int ToInt(string st, out int n) // convert st to an integer, n characters used
		{
			double val = 0;
			int i = 0;
			n = 0;
			bool sign = false;
			if (st != "" && (st[0] == '-' || st[i] == '+'))
			{
				sign = (st[0] == '-');
				i = 1;
				n = 1;
			}		
			while (true)
			{
				if (st.Length > i && st[i] >= '0' && st[i] <= '9')
				{
					val = val * 10 + st[i] - '0';
					i++;
					n++;
				}
				else
					break;
			}
			if (val > Int32.MaxValue)
				val = Int32.MaxValue;
			if (sign)
				val = -val;
			return (int)val;
		} // ToInt

		public static void Cleanup() // cleanup named list after a run-time error
		{
			GC.Collect();	// force garbage collection of all generations
		} // Cleanup

		public static string nL;		// one Environment.NewLine \n or \r or \r\n
		public static string cFCIn;		// code input File name
		public static string cFLOut;	// log output File name
	}
}
