using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MyNamespace
{
	/// <summary>
	///		Configuration form part of CrypF, a data encryption system, Forms version
	///		from Configuration form for XICalc - Extra Precision Integer Calculator
	///		Developed in TURBO Pascal 5.5 and 6.0, converted to Visual Basic 6
	///		and now in Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class ConfigForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		public ConfigForm()
		{
			InitializeComponent();

			// no constructor logic
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ConfigForm));
			this.timerConfig = new System.Windows.Forms.Timer(this.components);
			this.labelDiagOn = new System.Windows.Forms.Label();
			this.labelQuiet = new System.Windows.Forms.Label();
			this.labelLog = new System.Windows.Forms.Label();
			this.labelHomeDir = new System.Windows.Forms.Label();
			this.labelCFCIn = new System.Windows.Forms.Label();
			this.labelCFLOut = new System.Windows.Forms.Label();
			this.labelLogName = new System.Windows.Forms.Label();
			this.buttonDiagOn = new System.Windows.Forms.Button();
			this.buttonQuiet = new System.Windows.Forms.Button();
			this.buttonLog = new System.Windows.Forms.Button();
			this.buttonCFCIn = new System.Windows.Forms.Button();
			this.buttonCFLOut = new System.Windows.Forms.Button();
			this.buttonSaveConfig = new System.Windows.Forms.Button();
			this.buttonRestoreConfig = new System.Windows.Forms.Button();
			this.buttonChangeDir = new System.Windows.Forms.Button();
			this.buttonExit = new System.Windows.Forms.Button();
			this.textBoxCFCIn = new System.Windows.Forms.TextBox();
			this.textBoxCFLOut = new System.Windows.Forms.TextBox();
			this.listBoxFile = new System.Windows.Forms.ListBox();
			this.folderBrowserDialogConfig = new System.Windows.Forms.FolderBrowserDialog();
			this.openFileDialogConfig = new System.Windows.Forms.OpenFileDialog();
			this.buttonSelectFile = new System.Windows.Forms.Button();
			this.labelSelectedFile = new System.Windows.Forms.Label();
			this.labelFilePath = new System.Windows.Forms.Label();
			this.labelPri = new System.Windows.Forms.Label();
			this.textBoxPri = new System.Windows.Forms.TextBox();
			this.buttonPri = new System.Windows.Forms.Button();
			this.labelKeyIn = new System.Windows.Forms.Label();
			this.textBoxKeyIn = new System.Windows.Forms.TextBox();
			this.buttonKeyIn = new System.Windows.Forms.Button();
			this.labelKeyStd = new System.Windows.Forms.Label();
			this.labelKey24 = new System.Windows.Forms.Label();
			this.labelFileC = new System.Windows.Forms.Label();
			this.buttonFileC = new System.Windows.Forms.Button();
			this.textBoxFileC = new System.Windows.Forms.TextBox();
			this.labelFileD = new System.Windows.Forms.Label();
			this.labelFileE = new System.Windows.Forms.Label();
			this.labelFileK = new System.Windows.Forms.Label();
			this.labelFileX = new System.Windows.Forms.Label();
			this.buttonFileD = new System.Windows.Forms.Button();
			this.buttonFileE = new System.Windows.Forms.Button();
			this.buttonFileK = new System.Windows.Forms.Button();
			this.buttonFileX = new System.Windows.Forms.Button();
			this.textBoxFileD = new System.Windows.Forms.TextBox();
			this.textBoxFileE = new System.Windows.Forms.TextBox();
			this.textBoxFileK = new System.Windows.Forms.TextBox();
			this.textBoxFileX = new System.Windows.Forms.TextBox();
			this.buttonKeyF = new System.Windows.Forms.Button();
			this.buttonExecute = new System.Windows.Forms.Button();
			this.buttonEncode = new System.Windows.Forms.Button();
			this.buttonDecode = new System.Windows.Forms.Button();
			this.buttonInitC = new System.Windows.Forms.Button();
			this.labelCryCon = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// timerConfig
			// 
			this.timerConfig.Enabled = true;
			this.timerConfig.Interval = 500;
			this.timerConfig.Tick += new System.EventHandler(this.timerConfig_Tick);
			// 
			// labelDiagOn
			// 
			this.labelDiagOn.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelDiagOn.Location = new System.Drawing.Point(282, 37);
			this.labelDiagOn.Name = "labelDiagOn";
			this.labelDiagOn.Size = new System.Drawing.Size(136, 23);
			this.labelDiagOn.TabIndex = 5;
			this.labelDiagOn.Text = "Diagnostic mode:";
			// 
			// labelQuiet
			// 
			this.labelQuiet.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelQuiet.Location = new System.Drawing.Point(320, 67);
			this.labelQuiet.Name = "labelQuiet";
			this.labelQuiet.Size = new System.Drawing.Size(96, 16);
			this.labelQuiet.TabIndex = 8;
			this.labelQuiet.Text = "Quiet mode:";
			// 
			// labelLog
			// 
			this.labelLog.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelLog.Location = new System.Drawing.Point(120, 169);
			this.labelLog.Name = "labelLog";
			this.labelLog.Size = new System.Drawing.Size(144, 16);
			this.labelLog.TabIndex = 9;
			this.labelLog.Text = "Log to file mode:";
			// 
			// labelHomeDir
			// 
			this.labelHomeDir.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelHomeDir.Location = new System.Drawing.Point(32, 191);
			this.labelHomeDir.Name = "labelHomeDir";
			this.labelHomeDir.Size = new System.Drawing.Size(640, 16);
			this.labelHomeDir.TabIndex = 10;
			this.labelHomeDir.Text = "Home Dir: C:\\MMMMMMMMMMMM\\MMMMMMMMMM\\MMMMMMMMMMM\\MMMMMMMMM\\MMMMMM\\MMMMM";
			// 
			// labelCFCIn
			// 
			this.labelCFCIn.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCFCIn.Location = new System.Drawing.Point(20, 239);
			this.labelCFCIn.Name = "labelCFCIn";
			this.labelCFCIn.Size = new System.Drawing.Size(456, 16);
			this.labelCFCIn.TabIndex = 12;
			this.labelCFCIn.Text = "Calculator code file CFCIn: <Not set>";
			// 
			// labelCFLOut
			// 
			this.labelCFLOut.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCFLOut.Location = new System.Drawing.Point(52, 283);
			this.labelCFLOut.Name = "labelCFLOut";
			this.labelCFLOut.Size = new System.Drawing.Size(424, 16);
			this.labelCFLOut.TabIndex = 13;
			this.labelCFLOut.Text = "Output log file CFLOut: <Not set>";
			// 
			// labelLogName
			// 
			this.labelLogName.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelLogName.Location = new System.Drawing.Point(358, 169);
			this.labelLogName.Name = "labelLogName";
			this.labelLogName.Size = new System.Drawing.Size(312, 16);
			this.labelLogName.TabIndex = 17;
			this.labelLogName.Text = "To log file: NoName.CFL";
			// 
			// buttonDiagOn
			// 
			this.buttonDiagOn.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonDiagOn.Location = new System.Drawing.Point(424, 37);
			this.buttonDiagOn.Name = "buttonDiagOn";
			this.buttonDiagOn.Size = new System.Drawing.Size(88, 21);
			this.buttonDiagOn.TabIndex = 110;
			this.buttonDiagOn.Text = "Is Off";
			this.buttonDiagOn.Click += new System.EventHandler(this.buttonDiagOn_Click);
			// 
			// buttonQuiet
			// 
			this.buttonQuiet.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonQuiet.Location = new System.Drawing.Point(424, 66);
			this.buttonQuiet.Name = "buttonQuiet";
			this.buttonQuiet.Size = new System.Drawing.Size(88, 21);
			this.buttonQuiet.TabIndex = 113;
			this.buttonQuiet.Text = "Is Off";
			this.buttonQuiet.Click += new System.EventHandler(this.buttonQuiet_Click);
			// 
			// buttonLog
			// 
			this.buttonLog.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonLog.Location = new System.Drawing.Point(264, 169);
			this.buttonLog.Name = "buttonLog";
			this.buttonLog.Size = new System.Drawing.Size(88, 21);
			this.buttonLog.TabIndex = 114;
			this.buttonLog.Text = "Is Off";
			this.buttonLog.Click += new System.EventHandler(this.buttonLog_Click);
			// 
			// buttonCFCIn
			// 
			this.buttonCFCIn.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonCFCIn.Location = new System.Drawing.Point(120, 259);
			this.buttonCFCIn.Name = "buttonCFCIn";
			this.buttonCFCIn.Size = new System.Drawing.Size(112, 21);
			this.buttonCFCIn.TabIndex = 117;
			this.buttonCFCIn.Text = "Change It";
			this.buttonCFCIn.Click += new System.EventHandler(this.buttonCFCIn_Click);
			// 
			// buttonCFLOut
			// 
			this.buttonCFLOut.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonCFLOut.Location = new System.Drawing.Point(120, 302);
			this.buttonCFLOut.Name = "buttonCFLOut";
			this.buttonCFLOut.Size = new System.Drawing.Size(112, 21);
			this.buttonCFLOut.TabIndex = 118;
			this.buttonCFLOut.Text = "Change It";
			this.buttonCFLOut.Click += new System.EventHandler(this.buttonCFLOut_Click);
			// 
			// buttonSaveConfig
			// 
			this.buttonSaveConfig.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonSaveConfig.Location = new System.Drawing.Point(536, 9);
			this.buttonSaveConfig.Name = "buttonSaveConfig";
			this.buttonSaveConfig.Size = new System.Drawing.Size(72, 40);
			this.buttonSaveConfig.TabIndex = 127;
			this.buttonSaveConfig.Text = "Save Config";
			this.buttonSaveConfig.Click += new System.EventHandler(this.buttonSaveConfig_Click);
			// 
			// buttonRestoreConfig
			// 
			this.buttonRestoreConfig.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonRestoreConfig.Location = new System.Drawing.Point(536, 50);
			this.buttonRestoreConfig.Name = "buttonRestoreConfig";
			this.buttonRestoreConfig.Size = new System.Drawing.Size(72, 40);
			this.buttonRestoreConfig.TabIndex = 128;
			this.buttonRestoreConfig.Text = "Restore Config";
			this.buttonRestoreConfig.Click += new System.EventHandler(this.buttonRestoreConfig_Click);
			// 
			// buttonChangeDir
			// 
			this.buttonChangeDir.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonChangeDir.Location = new System.Drawing.Point(536, 94);
			this.buttonChangeDir.Name = "buttonChangeDir";
			this.buttonChangeDir.Size = new System.Drawing.Size(72, 48);
			this.buttonChangeDir.TabIndex = 129;
			this.buttonChangeDir.Text = "Change File Path";
			this.buttonChangeDir.Click += new System.EventHandler(this.buttonChangeDir_Click);
			// 
			// buttonExit
			// 
			this.buttonExit.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonExit.Location = new System.Drawing.Point(614, 60);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(64, 24);
			this.buttonExit.TabIndex = 131;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			// 
			// textBoxCFCIn
			// 
			this.textBoxCFCIn.Location = new System.Drawing.Point(241, 258);
			this.textBoxCFCIn.Name = "textBoxCFCIn";
			this.textBoxCFCIn.Size = new System.Drawing.Size(232, 22);
			this.textBoxCFCIn.TabIndex = 121;
			this.textBoxCFCIn.TextChanged += new System.EventHandler(this.textBoxCFCIn_TextChanged);
			this.textBoxCFCIn.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxCFCIn_KeyDown);
			// 
			// textBoxCFLOut
			// 
			this.textBoxCFLOut.Location = new System.Drawing.Point(238, 302);
			this.textBoxCFLOut.Name = "textBoxCFLOut";
			this.textBoxCFLOut.Size = new System.Drawing.Size(232, 22);
			this.textBoxCFLOut.TabIndex = 122;
			this.textBoxCFLOut.TextChanged += new System.EventHandler(this.textBoxCFLOut_TextChanged);
			this.textBoxCFLOut.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxCFLOut_KeyDown);
			// 
			// listBoxFile
			// 
			this.listBoxFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.listBoxFile.ItemHeight = 16;
			this.listBoxFile.Location = new System.Drawing.Point(478, 237);
			this.listBoxFile.Name = "listBoxFile";
			this.listBoxFile.ScrollAlwaysVisible = true;
			this.listBoxFile.Size = new System.Drawing.Size(200, 308);
			this.listBoxFile.TabIndex = 125;
			this.listBoxFile.SelectedIndexChanged += new System.EventHandler(this.listBoxFile_SelectedIndexChanged);
			// 
			// openFileDialogConfig
			// 
			this.openFileDialogConfig.Title = "<Title ?>";
			// 
			// buttonSelectFile
			// 
			this.buttonSelectFile.Location = new System.Drawing.Point(614, 94);
			this.buttonSelectFile.Name = "buttonSelectFile";
			this.buttonSelectFile.Size = new System.Drawing.Size(64, 48);
			this.buttonSelectFile.TabIndex = 130;
			this.buttonSelectFile.Text = "Select a File";
			this.buttonSelectFile.Click += new System.EventHandler(this.buttonSelectFile_Click);
			// 
			// labelSelectedFile
			// 
			this.labelSelectedFile.Location = new System.Drawing.Point(121, 223);
			this.labelSelectedFile.Name = "labelSelectedFile";
			this.labelSelectedFile.Size = new System.Drawing.Size(352, 16);
			this.labelSelectedFile.TabIndex = 48;
			this.labelSelectedFile.Text = "Selected file: NoName.CFL";
			// 
			// labelFilePath
			// 
			this.labelFilePath.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelFilePath.Location = new System.Drawing.Point(24, 207);
			this.labelFilePath.Name = "labelFilePath";
			this.labelFilePath.Size = new System.Drawing.Size(648, 16);
			this.labelFilePath.TabIndex = 11;
			this.labelFilePath.Text = "File path: C:\\MMMMMMMMMMMM\\MMMMMMMMMM\\MMMMMMMMMMM\\MMMMMMMMM\\MMMMMM\\MMMMM";
			// 
			// labelPri
			// 
			this.labelPri.Location = new System.Drawing.Point(52, 10);
			this.labelPri.Name = "labelPri";
			this.labelPri.Size = new System.Drawing.Size(256, 23);
			this.labelPri.TabIndex = 132;
			this.labelPri.Text = "Execution Priority [-2, 2] = -2";
			// 
			// textBoxPri
			// 
			this.textBoxPri.Location = new System.Drawing.Point(320, 9);
			this.textBoxPri.Name = "textBoxPri";
			this.textBoxPri.Size = new System.Drawing.Size(96, 22);
			this.textBoxPri.TabIndex = 133;
			this.textBoxPri.TextChanged += new System.EventHandler(this.textBoxPri_TextChanged);
			this.textBoxPri.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxPri_KeyDown);
			// 
			// buttonPri
			// 
			this.buttonPri.Location = new System.Drawing.Point(424, 10);
			this.buttonPri.Name = "buttonPri";
			this.buttonPri.Size = new System.Drawing.Size(96, 21);
			this.buttonPri.TabIndex = 134;
			this.buttonPri.Text = "Change It";
			this.buttonPri.Click += new System.EventHandler(this.buttonPri_Click);
			// 
			// labelKeyIn
			// 
			this.labelKeyIn.Location = new System.Drawing.Point(2, 88);
			this.labelKeyIn.Name = "labelKeyIn";
			this.labelKeyIn.Size = new System.Drawing.Size(520, 16);
			this.labelKeyIn.TabIndex = 135;
			this.labelKeyIn.Text = "KeyIn = TRY/TO/MAKE/YOUR/KEYS/EASY/TO/REMEMBER/BUT/HARD/TO/BREAK";
			// 
			// textBoxKeyIn
			// 
			this.textBoxKeyIn.Location = new System.Drawing.Point(5, 107);
			this.textBoxKeyIn.Name = "textBoxKeyIn";
			this.textBoxKeyIn.Size = new System.Drawing.Size(503, 22);
			this.textBoxKeyIn.TabIndex = 136;
			this.textBoxKeyIn.TextChanged += new System.EventHandler(this.textBoxKeyIn_TextChanged);
			this.textBoxKeyIn.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxKeyIn_KeyDown);
			// 
			// buttonKeyIn
			// 
			this.buttonKeyIn.Location = new System.Drawing.Point(12, 64);
			this.buttonKeyIn.Name = "buttonKeyIn";
			this.buttonKeyIn.Size = new System.Drawing.Size(113, 23);
			this.buttonKeyIn.TabIndex = 137;
			this.buttonKeyIn.Text = "Change KeyIn";
			this.buttonKeyIn.UseVisualStyleBackColor = true;
			this.buttonKeyIn.Click += new System.EventHandler(this.buttonKeyIn_Click);
			// 
			// labelKeyStd
			// 
			this.labelKeyStd.Location = new System.Drawing.Point(2, 132);
			this.labelKeyStd.Name = "labelKeyStd";
			this.labelKeyStd.Size = new System.Drawing.Size(528, 16);
			this.labelKeyStd.TabIndex = 138;
			this.labelKeyStd.Text = "KeyStd = TRY/TO/MAKE/YOUR/KEYS/EASY/TO/REMEMBER/BUT/HARD/TO/BREAK";
			// 
			// labelKey24
			// 
			this.labelKey24.AutoSize = true;
			this.labelKey24.Location = new System.Drawing.Point(2, 148);
			this.labelKey24.Name = "labelKey24";
			this.labelKey24.Size = new System.Drawing.Size(264, 16);
			this.labelKey24.TabIndex = 139;
			this.labelKey24.Text = "Key24 = U/1\"@N)C422T+58;(>/9D2%\"";
			// 
			// labelFileC
			// 
			this.labelFileC.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelFileC.Location = new System.Drawing.Point(24, 327);
			this.labelFileC.Name = "labelFileC";
			this.labelFileC.Size = new System.Drawing.Size(452, 16);
			this.labelFileC.TabIndex = 140;
			this.labelFileC.Text = "Clear file to be encrypted FileC: <Not set>";
			// 
			// buttonFileC
			// 
			this.buttonFileC.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonFileC.Location = new System.Drawing.Point(123, 346);
			this.buttonFileC.Name = "buttonFileC";
			this.buttonFileC.Size = new System.Drawing.Size(112, 21);
			this.buttonFileC.TabIndex = 141;
			this.buttonFileC.Text = "Change It";
			this.buttonFileC.Click += new System.EventHandler(this.buttonFileC_Click);
			// 
			// textBoxFileC
			// 
			this.textBoxFileC.Location = new System.Drawing.Point(241, 346);
			this.textBoxFileC.Name = "textBoxFileC";
			this.textBoxFileC.Size = new System.Drawing.Size(232, 22);
			this.textBoxFileC.TabIndex = 142;
			this.textBoxFileC.TextChanged += new System.EventHandler(this.textBoxFileC_TextChanged);
			this.textBoxFileC.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxFileC_KeyDown);
			// 
			// labelFileD
			// 
			this.labelFileD.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelFileD.Location = new System.Drawing.Point(32, 417);
			this.labelFileD.Name = "labelFileD";
			this.labelFileD.Size = new System.Drawing.Size(444, 16);
			this.labelFileD.TabIndex = 143;
			this.labelFileD.Text = "File to decrypt to FileD: <Not set>";
			// 
			// labelFileE
			// 
			this.labelFileE.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelFileE.Location = new System.Drawing.Point(32, 371);
			this.labelFileE.Name = "labelFileE";
			this.labelFileE.Size = new System.Drawing.Size(444, 16);
			this.labelFileE.TabIndex = 144;
			this.labelFileE.Text = "File to encrypt to FileE: <Not set>";
			// 
			// labelFileK
			// 
			this.labelFileK.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelFileK.Location = new System.Drawing.Point(117, 459);
			this.labelFileK.Name = "labelFileK";
			this.labelFileK.Size = new System.Drawing.Size(359, 16);
			this.labelFileK.TabIndex = 145;
			this.labelFileK.Text = "Key file FileK: <Not set>";
			// 
			// labelFileX
			// 
			this.labelFileX.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelFileX.Location = new System.Drawing.Point(24, 503);
			this.labelFileX.Name = "labelFileX";
			this.labelFileX.Size = new System.Drawing.Size(452, 16);
			this.labelFileX.TabIndex = 146;
			this.labelFileX.Text = "eXecute command file FileX: <Not set>";
			// 
			// buttonFileD
			// 
			this.buttonFileD.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonFileD.Location = new System.Drawing.Point(123, 435);
			this.buttonFileD.Name = "buttonFileD";
			this.buttonFileD.Size = new System.Drawing.Size(112, 21);
			this.buttonFileD.TabIndex = 147;
			this.buttonFileD.Text = "Change It";
			this.buttonFileD.Click += new System.EventHandler(this.buttonFileD_Click);
			// 
			// buttonFileE
			// 
			this.buttonFileE.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonFileE.Location = new System.Drawing.Point(123, 392);
			this.buttonFileE.Name = "buttonFileE";
			this.buttonFileE.Size = new System.Drawing.Size(112, 21);
			this.buttonFileE.TabIndex = 148;
			this.buttonFileE.Text = "Change It";
			this.buttonFileE.Click += new System.EventHandler(this.buttonFileE_Click);
			// 
			// buttonFileK
			// 
			this.buttonFileK.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonFileK.Location = new System.Drawing.Point(124, 478);
			this.buttonFileK.Name = "buttonFileK";
			this.buttonFileK.Size = new System.Drawing.Size(112, 21);
			this.buttonFileK.TabIndex = 149;
			this.buttonFileK.Text = "Change It";
			this.buttonFileK.Click += new System.EventHandler(this.buttonFileK_Click);
			// 
			// buttonFileX
			// 
			this.buttonFileX.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonFileX.Location = new System.Drawing.Point(123, 523);
			this.buttonFileX.Name = "buttonFileX";
			this.buttonFileX.Size = new System.Drawing.Size(112, 21);
			this.buttonFileX.TabIndex = 150;
			this.buttonFileX.Text = "Change It";
			this.buttonFileX.Click += new System.EventHandler(this.buttonFileX_Click);
			// 
			// textBoxFileD
			// 
			this.textBoxFileD.Location = new System.Drawing.Point(240, 435);
			this.textBoxFileD.Name = "textBoxFileD";
			this.textBoxFileD.Size = new System.Drawing.Size(232, 22);
			this.textBoxFileD.TabIndex = 151;
			this.textBoxFileD.TextChanged += new System.EventHandler(this.textBoxFileD_TextChanged);
			this.textBoxFileD.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxFileD_KeyDown);
			// 
			// textBoxFileE
			// 
			this.textBoxFileE.Location = new System.Drawing.Point(240, 392);
			this.textBoxFileE.Name = "textBoxFileE";
			this.textBoxFileE.Size = new System.Drawing.Size(232, 22);
			this.textBoxFileE.TabIndex = 152;
			this.textBoxFileE.TextChanged += new System.EventHandler(this.textBoxFileE_TextChanged);
			this.textBoxFileE.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxFileE_KeyDown);
			// 
			// textBoxFileK
			// 
			this.textBoxFileK.Location = new System.Drawing.Point(241, 478);
			this.textBoxFileK.Name = "textBoxFileK";
			this.textBoxFileK.Size = new System.Drawing.Size(232, 22);
			this.textBoxFileK.TabIndex = 153;
			this.textBoxFileK.TextChanged += new System.EventHandler(this.textBoxFileK_TextChanged);
			this.textBoxFileK.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxFileK_KeyDown);
			// 
			// textBoxFileX
			// 
			this.textBoxFileX.Location = new System.Drawing.Point(238, 522);
			this.textBoxFileX.Name = "textBoxFileX";
			this.textBoxFileX.Size = new System.Drawing.Size(232, 22);
			this.textBoxFileX.TabIndex = 154;
			this.textBoxFileX.TextChanged += new System.EventHandler(this.textBoxFileX_TextChanged);
			this.textBoxFileX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxFileX_KeyDown);
			// 
			// buttonKeyF
			// 
			this.buttonKeyF.Location = new System.Drawing.Point(5, 478);
			this.buttonKeyF.Name = "buttonKeyF";
			this.buttonKeyF.Size = new System.Drawing.Size(113, 23);
			this.buttonKeyF.TabIndex = 155;
			this.buttonKeyF.Text = "Read FileK";
			this.buttonKeyF.UseVisualStyleBackColor = true;
			this.buttonKeyF.Click += new System.EventHandler(this.buttonKeyF_Click);
			// 
			// buttonExecute
			// 
			this.buttonExecute.Location = new System.Drawing.Point(5, 521);
			this.buttonExecute.Name = "buttonExecute";
			this.buttonExecute.Size = new System.Drawing.Size(113, 23);
			this.buttonExecute.TabIndex = 156;
			this.buttonExecute.Text = "Execute File";
			this.buttonExecute.UseVisualStyleBackColor = true;
			this.buttonExecute.Click += new System.EventHandler(this.buttonExecute_Click);
			// 
			// buttonEncode
			// 
			this.buttonEncode.Location = new System.Drawing.Point(5, 390);
			this.buttonEncode.Name = "buttonEncode";
			this.buttonEncode.Size = new System.Drawing.Size(113, 23);
			this.buttonEncode.TabIndex = 157;
			this.buttonEncode.Text = "Encode";
			this.buttonEncode.UseVisualStyleBackColor = true;
			this.buttonEncode.Click += new System.EventHandler(this.buttonEncode_Click);
			// 
			// buttonDecode
			// 
			this.buttonDecode.Location = new System.Drawing.Point(5, 436);
			this.buttonDecode.Name = "buttonDecode";
			this.buttonDecode.Size = new System.Drawing.Size(113, 23);
			this.buttonDecode.TabIndex = 158;
			this.buttonDecode.Text = "Decode";
			this.buttonDecode.UseVisualStyleBackColor = true;
			this.buttonDecode.Click += new System.EventHandler(this.buttonDecode_Click);
			// 
			// buttonInitC
			// 
			this.buttonInitC.Location = new System.Drawing.Point(153, 64);
			this.buttonInitC.Name = "buttonInitC";
			this.buttonInitC.Size = new System.Drawing.Size(113, 23);
			this.buttonInitC.TabIndex = 159;
			this.buttonInitC.Text = "Init Cry.con";
			this.buttonInitC.UseVisualStyleBackColor = true;
			this.buttonInitC.Click += new System.EventHandler(this.buttonInitC_Click);
			// 
			// labelCryCon
			// 
			this.labelCryCon.AutoSize = true;
			this.labelCryCon.Location = new System.Drawing.Point(292, 148);
			this.labelCryCon.Name = "labelCryCon";
			this.labelCryCon.Size = new System.Drawing.Size(376, 16);
			this.labelCryCon.TabIndex = 160;
			this.labelCryCon.Text = "Cry.con = 8170968691454FD7293A61FB27015BCBCBD9";
			// 
			// ConfigForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(8, 15);
			this.ClientSize = new System.Drawing.Size(680, 550);
			this.Controls.Add(this.labelCryCon);
			this.Controls.Add(this.buttonInitC);
			this.Controls.Add(this.buttonDecode);
			this.Controls.Add(this.buttonEncode);
			this.Controls.Add(this.buttonExecute);
			this.Controls.Add(this.buttonKeyF);
			this.Controls.Add(this.textBoxFileX);
			this.Controls.Add(this.textBoxFileK);
			this.Controls.Add(this.textBoxFileE);
			this.Controls.Add(this.textBoxFileD);
			this.Controls.Add(this.buttonFileX);
			this.Controls.Add(this.buttonFileK);
			this.Controls.Add(this.buttonFileE);
			this.Controls.Add(this.buttonFileD);
			this.Controls.Add(this.labelFileX);
			this.Controls.Add(this.labelFileK);
			this.Controls.Add(this.labelFileE);
			this.Controls.Add(this.labelFileD);
			this.Controls.Add(this.textBoxFileC);
			this.Controls.Add(this.buttonFileC);
			this.Controls.Add(this.labelFileC);
			this.Controls.Add(this.labelKey24);
			this.Controls.Add(this.labelKeyStd);
			this.Controls.Add(this.buttonKeyIn);
			this.Controls.Add(this.textBoxKeyIn);
			this.Controls.Add(this.labelKeyIn);
			this.Controls.Add(this.buttonPri);
			this.Controls.Add(this.textBoxPri);
			this.Controls.Add(this.textBoxCFLOut);
			this.Controls.Add(this.textBoxCFCIn);
			this.Controls.Add(this.labelPri);
			this.Controls.Add(this.labelSelectedFile);
			this.Controls.Add(this.buttonSelectFile);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonChangeDir);
			this.Controls.Add(this.buttonRestoreConfig);
			this.Controls.Add(this.buttonSaveConfig);
			this.Controls.Add(this.buttonCFLOut);
			this.Controls.Add(this.buttonCFCIn);
			this.Controls.Add(this.buttonLog);
			this.Controls.Add(this.buttonQuiet);
			this.Controls.Add(this.buttonDiagOn);
			this.Controls.Add(this.listBoxFile);
			this.Controls.Add(this.labelLogName);
			this.Controls.Add(this.labelCFLOut);
			this.Controls.Add(this.labelCFCIn);
			this.Controls.Add(this.labelFilePath);
			this.Controls.Add(this.labelHomeDir);
			this.Controls.Add(this.labelLog);
			this.Controls.Add(this.labelQuiet);
			this.Controls.Add(this.labelDiagOn);
			this.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ConfigForm";
			this.Text = "ConfigForm";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.ConfigForm_Closing);
			this.Load += new System.EventHandler(this.ConfigForm_Load);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		private System.Windows.Forms.Timer timerConfig;
		private System.Windows.Forms.Label labelDiagOn;
		private System.Windows.Forms.Label labelQuiet;
		private System.Windows.Forms.Label labelLog;
		private System.Windows.Forms.Label labelHomeDir;
		private System.Windows.Forms.Label labelCFCIn;
		private System.Windows.Forms.Label labelCFLOut;
		private System.Windows.Forms.Label labelLogName;
		private System.Windows.Forms.Button buttonCFCIn;
		private System.Windows.Forms.Button buttonCFLOut;
		private System.Windows.Forms.Button buttonSaveConfig;
		private System.Windows.Forms.Button buttonRestoreConfig;
		private System.Windows.Forms.Button buttonChangeDir;
		private System.Windows.Forms.Button buttonExit;
		private System.Windows.Forms.TextBox textBoxCFCIn;
		private System.Windows.Forms.TextBox textBoxCFLOut;
		private System.Windows.Forms.Button buttonDiagOn;
		private System.Windows.Forms.Button buttonQuiet;
		private System.Windows.Forms.Button buttonLog;
		private System.Windows.Forms.ListBox listBoxFile;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialogConfig;
		private System.Windows.Forms.OpenFileDialog openFileDialogConfig;
		private System.Windows.Forms.Label labelSelectedFile;
		private System.Windows.Forms.Label labelFilePath;
		private System.Windows.Forms.Label labelPri;
		private System.Windows.Forms.TextBox textBoxPri;
		private System.Windows.Forms.Button buttonPri;
		private Label labelKeyIn;
		private TextBox textBoxKeyIn;
		private Button buttonKeyIn;
		private Label labelKeyStd;
		private Label labelKey24;
		private Label labelFileC;
		private Button buttonFileC;
		private TextBox textBoxFileC;
		private Label labelFileD;
		private Label labelFileE;
		private Label labelFileK;
		private Label labelFileX;
		private Button buttonFileD;
		private Button buttonFileE;
		private Button buttonFileK;
		private Button buttonFileX;
		private TextBox textBoxFileD;
		private TextBox textBoxFileE;
		private TextBox textBoxFileK;
		private TextBox textBoxFileX;
		private Button buttonKeyF;
		private Button buttonExecute;
		private Button buttonEncode;
		private Button buttonDecode;
		private Button buttonInitC;
		private Label labelCryCon;
		private System.Windows.Forms.Button buttonSelectFile;

		// -------- Begin Main program, Configuration
		public void Config()
		{
			// don't allow Config form to be brought up more than once
			if (Common.configUp) { Dispose(true); return; }
			Common.configUp = true;
			this.Text = Global.title + " - Configuration";
			labelHomeDir.Text = "Home Dir: " + Common.homeDir;
			timerConfig_Tick();
			textBoxKeyIn.Focus();
			GetFileNames();
		}

		private void GetFileNames() // populate the listBoxFile with file names
		{
			try
			{
				DirectoryInfo di = new DirectoryInfo(Environment.CurrentDirectory);
				listBoxFile.Items.Clear();
				string filter = "*.CF?";
				if (Common.selectFilter == 2) filter = "*.txt";
				if (Common.selectFilter > 2) filter = "*.*";
				foreach (FileInfo FI in di.GetFiles(filter))
				{
					listBoxFile.Items.Add(FI.Name);
				}
			}
			catch (Exception ex)
			{
				Common.ReportError("GetFileNames:", ex.Message);
			}
		}

		private void buttonChangeDir_Click(object sender, System.EventArgs e)
		// bring up folderBrowserDialog
		{
			folderBrowserDialogConfig.SelectedPath = Environment.CurrentDirectory;
			folderBrowserDialogConfig.Description = Global.title + " - Select a file path";
			folderBrowserDialogConfig.ShowDialog();
			Directory.SetCurrentDirectory(folderBrowserDialogConfig.SelectedPath);
			Common.selectPath = Environment.CurrentDirectory;
			GetFileNames();
		}

		private void buttonDiagOn_Click(object sender, System.EventArgs e)
		// toggle Diagnostic display mode Off/Time/Diag/Debug
		{
				 if (!MultiID.timeIt) MultiID.timeIt = true;
			else if (!MultiID.diagOn) MultiID.diagOn = true;
			else if (!MultiID.debug)  MultiID.debug  = true;
			else
			{
				MultiID.debug  = false;
				MultiID.diagOn = false;
				MultiID.timeIt = false;
			}
			DisplayDiagOn();
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		// exit Configuration form
		{
			Common.configUp = false;
			Dispose(true);
		}

		private void buttonLog_Click(object sender, System.EventArgs e)
		// toggle Logging of output screen to Log File
		{
			Common.ToggleLogg();
			DisplayLog();
			buttonLog.Focus();
		}

		private void buttonPri_Click(object sender, System.EventArgs e)
		{
			buttonPri_Click();
		}

		private void buttonPri_Click()
		{
			int iL;
			if (textBoxPri.Text == "") // if "", set to current
				textBoxPri.Text = Common.pri.ToString();
			iL = Convert.ToInt32(textBoxPri.Text);
			Common.SetPriority(iL);
			textBoxPri.Text = Common.pri.ToString();
			DisplayPri();
			textBoxPri.Focus();
			textBoxPri.SelectionStart = textBoxPri.Text.Length;
		}

		private void buttonQuiet_Click(object sender, System.EventArgs e)
		// toggle quiet mode on/off
		{
			Common.quiet = !Common.quiet;
			DisplayQuiet();
		}

		private void buttonRestoreConfig_Click(object sender, System.EventArgs e)
		// restore configeration, same as < command
		{
			Common.DoubleSpace();
			Common.running = true;
			buttonRestoreConfig.Enabled = false;
			buttonSaveConfig.Enabled = false;
			Calc.CalReadConfig();
			buttonRestoreConfig.Enabled = true;
			buttonSaveConfig.Enabled = true;
			Common.running = false;
			RunForm.FocusBothUs();
			buttonRestoreConfig.Focus();
		}

		private void buttonSaveConfig_Click(object sender, System.EventArgs e)
		// save configuration, same as > command
		{
			Common.DoubleSpace();
			if (Common.running) return;
			Common.running = true;
			buttonRestoreConfig.Enabled = false;
			buttonSaveConfig.Enabled = false;
			Calc.CalWriteConfig();
			buttonRestoreConfig.Enabled = true;
			buttonSaveConfig.Enabled = true;
			Common.running = false;
			RunForm.FocusBothUs();
			buttonSaveConfig.Focus();
		}

		private void buttonSelectFile_Click(object sender, System.EventArgs e)
		// bring up openFileDialog
		{
			string st = Environment.CurrentDirectory.ToString();
			openFileDialogConfig.Reset();	// Reset needed to be able to change InitialDirectory
			openFileDialogConfig.InitialDirectory = st;
			openFileDialogConfig.Filter = "CrypF files (*.CF?)|*.CF?|txt files (*.txt)|*.txt|All files(*.*)|*.*";
			openFileDialogConfig.FilterIndex = Common.selectFilter;
			openFileDialogConfig.RestoreDirectory = false;
			openFileDialogConfig.Title = Global.title + " - Select a file";
			if(openFileDialogConfig.ShowDialog() == DialogResult.OK)
			{
				st = openFileDialogConfig.FileName.ToString();
 				int i = st.LastIndexOf(@"\");					// seperate selected path and file strings
				Common.selectPath = st.Substring(0, i);
				Common.selectFile = st.Substring(i+1);
				Directory.SetCurrentDirectory(Common.selectPath);
				labelSelectedFile.Text = "Selected file: " + Common.selectFile;
			}
			Common.selectFilter = openFileDialogConfig.FilterIndex;
			GetFileNames();
		}

		private void buttonCFCIn_Click(object sender, System.EventArgs e)
		// change name of calculator code file
		{
			buttonCFCIn_Click();
		}

		private void buttonCFCIn_Click()
		// change name of calculator code file
		{
			Common.DoubleSpace();
			string st = textBoxCFCIn.Text;
			if (st != "")
			{
				Common.FixFName(ref st, "CFC");
				textBoxCFCIn.Text = st;
				if (st != "")
					Calc.cFCIn = st;
			}
			if (st == "")
			{
				if (Common.selectFile == "")
				{
					if (Calc.cFCIn != "") textBoxCFCIn.Text = Calc.cFCIn;
				}
				else
				{
					textBoxCFCIn.Text = Common.selectFile;
				}
			}
			DisplayCFCIn();
			RunForm.FocusBothUs();
			textBoxCFCIn.Focus();
			textBoxCFCIn.SelectionStart = textBoxCFCIn.Text.Length;
		}

		private void buttonCFLOut_Click(object sender, System.EventArgs e)
		// change name of output log file
		{
			buttonCFLOut_Click();
		}

		private void buttonCFLOut_Click()
		// change name of output log file
		{
			Common.DoubleSpace();
			string st = textBoxCFLOut.Text;
			if (st != "")
			{
				Common.FixFName(ref st, "CFL");
				textBoxCFLOut.Text = st;
				if (st != "")
					Calc.cFLOut = st;
			}
			if (st == "")
			{
				if (Common.selectFile == "")
				{
					if (Calc.cFLOut != "") textBoxCFLOut.Text = Calc.cFLOut;
				}
				else
				{
					textBoxCFLOut.Text = Common.selectFile;
				}
			}
			DisplayCFLOut();
			RunForm.FocusBothUs();
			textBoxCFLOut.Focus();
			textBoxCFLOut.SelectionStart = textBoxCFLOut.Text.Length;
		}

		private void DisplayDiagOn() // display Diagnostic mode: On/Off
		{
			if (MultiID.debug)
				buttonDiagOn.Text = "Debug";
			else if (MultiID.diagOn)
				buttonDiagOn.Text = "Diag";
			else if (MultiID.timeIt)
				buttonDiagOn.Text = "Time";
			else
				buttonDiagOn.Text = "Is Off";
		}

		private void DisplayLog() // display Log to file mode: On/Off
		{
			if (MultiID.logg)
				buttonLog.Text = "Is On";
			else
				buttonLog.Text = "Is Off";
		}

		private void DisplayLogName() // display name of open log file
		{
			if (MultiID.logg)
				labelLogName.Text = "To log file: " + Common.logFile;
			else
				labelLogName.Text = "";
		}

		private void DisplayPri() // display execution priority
		{
			labelPri.Text = "Execution Priority [-2, 2] = " + Common.pri;
		}

		private void DisplayQuiet() // display quiet mode: On/Off
		{
			if (Common.quiet)
				buttonQuiet.Text = "Is On";
			else
				buttonQuiet.Text = "Is Off";
		}

		private void DisplayKey() // display Key, KeyStd, and Key24
		{
			string st = Cryp.keyIn;
			if (st == "") st = "<Not set>";
			labelKeyIn.Text = "KeyIn = " + st;
			st = Cryp.keyStd;
			if (st == "") st = "<Not set>";
			labelKeyStd.Text = "KeyStd = " + st;
			st = Cryp.key24;
			if (st == "") st = "<Not set>";
			labelKey24.Text = "Key24 = " + st;
		}

		private void DisplayCryCon() // display contents of file Cry.con
		{
			string st = "";
			string st1;
			int byte0;
			int byte1;
			UInt16 byte2;
			for (int i = 0; i < 9; i++)
			{
				byte2 = Cryp.cryCon[i];
				byte1 = Math.DivRem(byte2, 256, out byte0);
				st1 = byte0.ToString("X");
				if (st1.Length == 1)
					st1 = "0" + st1;
				st += st1;
				st1 = byte1.ToString("X");
				if (st1.Length == 1)
					st1 = "0" + st1;
				st += st1;
			}
			labelCryCon.Text = "Cry.con = " + st;
		}

		private void DisplayCFCIn() // display name of Calculator code file
		{
			string st = Calc.cFCIn;
			if (st == "") st = "<Not set>";
			labelCFCIn.Text = "Calculator code file CFCIn: " + st;
		}

		private void DisplayCFLOut() // display name of Output Log file
		{
			string st = Calc.cFLOut;
			if (st == "") st = "<Not set>";
			labelCFLOut.Text = "Output log file CFLOut: " + st;
		}

		private void DisplayFileC() // display name of FileC
		{
			string st = Cryp.fileC;
			if (st == "") st = "<Not set>";
			labelFileC.Text = "Clear file to be encrypted FileC: " + st;
		}

		private void DisplayFileD() // display name of FileD
		{
			string st = Cryp.fileD;
			if (st == "") st = "<Not set>";
			labelFileD.Text = "File to decrypt to FileD: " + st;
		}

		private void DisplayFileE() // display name of FileE
		{
			string st = Cryp.fileE;
			if (st == "") st = "<Not set>";
			labelFileE.Text = "File to encrypt to FileE: " + st;
		}

		private void DisplayFileK() // display name of FileK
		{
			string st = Cryp.fileK;
			if (st == "") st = "<Not set>";
			labelFileK.Text = "Key file FileK: " + st;
		}

		private void DisplayFileX() // display name of FileX
		{
			string st = Cryp.fileX;
			if (st == "") st = "<Not set>";
			labelFileX.Text = "eXecute command file FileX: " + st;
		}

		private void listBoxFile_SelectedIndexChanged(object sender, System.EventArgs e)
		// save the selected file name
		{
			int i = listBoxFile.SelectedIndex;
			Common.selectFile = listBoxFile.Items[i].ToString();
		}

		private void textBoxPri_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in Pri box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonPri.Enabled) buttonPri_Click();
			}
		}

		private void textBoxPri_TextChanged(object sender, System.EventArgs e)
		// process input of Execution Priority
		{
			textBoxPri_TextChanged();
		}

		private void textBoxPri_TextChanged()
		// process input of Execution Priority
		{
			string sNum;
			int iNum;
			int n;
			// allow a change when Calc is running
			textBoxPri.Text = textBoxPri.Text.TrimStart(' '); // remove leading spaces
			if (textBoxPri.Text == "")
			{
				buttonPri.Enabled = true;
				return;
			}
			sNum = textBoxPri.Text;
			if (Global.IsInt32(sNum))
			{
				buttonPri.Enabled = true;
				iNum = Convert.ToInt32(sNum);
			}
			else
				buttonPri.Enabled = false;
			n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxPri.Text = textBoxPri.Text.Trim(' ');		// remove trailing spaces
					textBoxPri.SelectionStart = textBoxPri.Text.Length; // move to right end of input
					if (buttonPri.Enabled) buttonPri_Click();			// accept the input
				}
			}
		}

		private void textBoxCFCIn_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in CFCIn box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonCFCIn.Enabled) buttonCFCIn_Click();
			}
		}

		private void textBoxCFCIn_TextChanged(object sender, System.EventArgs e)
		// process input of name of calculator code file
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxCFCIn.Text = textBoxCFCIn.Text.TrimStart(' '); // remove leading spaces
			st = textBoxCFCIn.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonCFCIn.Enabled = true;
				return;
			}
		}

		private void textBoxCFLOut_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in CFLOut box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonCFLOut.Enabled) buttonCFLOut_Click();
			}
		}

		private void textBoxCFLOut_TextChanged(object sender, System.EventArgs e)
		// process input of name of output log file
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxCFLOut.Text = textBoxCFLOut.Text.TrimStart(' '); // remove leading spaces
			st = textBoxCFLOut.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonCFLOut.Enabled = true;
				return;
			}
		}

		private void timerConfig_Tick(object sender, System.EventArgs e)
		// update display of changeable items
		{
			if (!Global.runFormUp)
			{
				Common.configUp = false;
				Dispose(true);
				return;
			}
			timerConfig_Tick();
		}

		private void timerConfig_Tick()	// update display of changeable items
		{
			labelSelectedFile.Text = "Selected file: " + Common.selectFile;
			labelFilePath.Text = "File path: " + Environment.CurrentDirectory.ToString();
			DisplayDiagOn();
			DisplayLog();
			DisplayLogName();
			DisplayPri();
			DisplayKey();
			DisplayCryCon();
			DisplayCFCIn();
			DisplayCFLOut();
			DisplayFileC();
			DisplayFileD();
			DisplayFileE();
			DisplayFileK();
			DisplayFileX();
			DisplayQuiet();
			if (Common.running)
			{
				buttonChangeDir.Enabled = false;
				buttonCFCIn.Enabled = false;
				buttonCFLOut.Enabled = false;
				buttonRestoreConfig.Enabled = false;
				buttonSaveConfig.Enabled = false;
			}
			else
			{
				buttonChangeDir.Enabled = true;
				buttonCFCIn.Enabled = true;
				buttonCFLOut.Enabled = true;
				buttonRestoreConfig.Enabled = true;
				buttonSaveConfig.Enabled = true;
			}
		} // timerConfig_Tick

		private void ConfigForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		// exit Configuration form
		{
			Common.configUp = false;
		}

		private void ConfigForm_Load(object sender, System.EventArgs e)
		{
		
		}

		private void buttonKeyF_Click(object sender, EventArgs e)
		{
			Cryp.GetKeyF();
			textBoxKeyIn.Text = Cryp.keyIn;
			DisplayKey();
			RunForm.FocusBothUs();
			textBoxKeyIn.Focus();
			textBoxKeyIn.SelectionStart = textBoxKeyIn.Text.Length;
		}

		private void textBoxKeyIn_KeyDown(object sender, KeyEventArgs e)
		// process keys when in KeyIn box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonKeyIn.Enabled) buttonKeyIn_Click();
			}
			if (e.KeyCode == Keys.Escape) // ESC key pressed so exit ConfigForm
			{
				Common.configUp = false;
				Dispose(true);
			}
		}

		private void textBoxKeyIn_TextChanged(object sender, System.EventArgs e)
		// process input of KeyIn
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxKeyIn.Text = textBoxKeyIn.Text.TrimStart(' '); // remove leading spaces
			st = textBoxKeyIn.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonKeyIn.Enabled = true;
				return;
			}
		}

		private void buttonKeyIn_Click(object sender, EventArgs e)
		{
			buttonKeyIn_Click();
		}

		private void buttonKeyIn_Click()
		{
			textBoxKeyIn.Text = textBoxKeyIn.Text.Trim(' ');		// remove trailing spaces
			if (textBoxKeyIn.Text == "") // if "", set to current
				textBoxKeyIn.Text = Cryp.keyIn;
			Cryp.param = textBoxKeyIn.Text;
			Cryp.GetKey();
			DisplayKey();
			RunForm.FocusBothUs();
			textBoxKeyIn.Focus();
			textBoxKeyIn.SelectionStart = textBoxKeyIn.Text.Length;
		}

		private void buttonFileC_Click(object sender, EventArgs e)
		// change name of FileC
		{
			buttonFileC_Click();
		}

		private void buttonFileC_Click()
		// change name of FileC
		{
			Common.DoubleSpace();
			string st = textBoxFileC.Text;
			if (st != "")
			{
				Common.FixFName(ref st);
				textBoxFileC.Text = st;
				if (st != "")
				{
					Cryp.param = st;
					Cryp.FileC();
				}
			}
			if (st == "")
			{
				if (Common.selectFile == "")
				{
					if (Cryp.fileC != "") textBoxFileC.Text = Cryp.fileC;
				}
				else
				{
					textBoxFileC.Text = Common.selectFile;
				}
			}
			DisplayFileC();
			RunForm.FocusBothUs();
			textBoxFileC.Focus();
			textBoxFileC.SelectionStart = textBoxFileC.Text.Length;
		}

		private void buttonFileD_Click(object sender, EventArgs e)
		// change name of FileD
		{
			buttonFileD_Click();
		}
		private void buttonFileD_Click()
		// change name of FileD
		{
			Common.DoubleSpace();
			string st = textBoxFileD.Text;
			if (st != "")
			{
				Common.FixFName(ref st);
				textBoxFileD.Text = st;
				if (st != "")
				{
					Cryp.param = st;
					Cryp.FileD();
				}
			}
			if (st == "")
			{
				if (Common.selectFile == "")
				{
					if (Cryp.fileD != "") textBoxFileD.Text = Cryp.fileD;
				}
				else
				{
					textBoxFileD.Text = Common.selectFile;
				}
			}
			DisplayFileD();
			RunForm.FocusBothUs();
			textBoxFileD.Focus();
			textBoxFileD.SelectionStart = textBoxFileD.Text.Length;
		}

		private void buttonFileE_Click(object sender, EventArgs e)
		// change name of FileE
		{
			buttonFileE_Click();
		}
		private void buttonFileE_Click()
		// change name of FileE
		{
			Common.DoubleSpace();
			string st = textBoxFileE.Text;
			if (st != "")
			{
				Common.FixFName(ref st);
				textBoxFileE.Text = st;
				if (st != "")
				{
					Cryp.param = st;
					Cryp.FileE();
				}
			}
			if (st == "")
			{
				if (Common.selectFile == "")
				{
					if (Cryp.fileE != "") textBoxFileE.Text = Cryp.fileE;
				}
				else
				{
					textBoxFileE.Text = Common.selectFile;
				}
			}
			DisplayFileE();
			RunForm.FocusBothUs();
			textBoxFileE.Focus();
			textBoxFileE.SelectionStart = textBoxFileE.Text.Length;
		}

		private void buttonFileK_Click(object sender, EventArgs e)
		// change name of FileK
		{
			buttonFileK_Click();
		}
		private void buttonFileK_Click()
		// change name of FileK
		{
			Common.DoubleSpace();
			string st = textBoxFileK.Text;
			if (st != "")
			{
				Common.FixFName(ref st, "txt");
				textBoxFileK.Text = st;
				if (st != "")
				{
					Cryp.param = st;
					Cryp.FileK();
				}
			}
			if (st == "")
			{
				if (Common.selectFile == "")
				{
					if (Cryp.fileK != "") textBoxFileK.Text = Cryp.fileK;
				}
				else
				{
					textBoxFileK.Text = Common.selectFile;
				}
			}
			DisplayFileK();
			RunForm.FocusBothUs();
			textBoxFileK.Focus();
			textBoxFileK.SelectionStart = textBoxFileK.Text.Length;
		}

		private void buttonFileX_Click(object sender, EventArgs e)
		// change name of FileX
		{
			buttonFileX_Click();
		}
		private void buttonFileX_Click()
		// change name of FileX
		{
			Common.DoubleSpace();
			string st = textBoxFileX.Text;
			if (st != "")
			{
				Common.FixFName(ref st, "CFC");
				textBoxFileX.Text = st;
				if (st != "")
				{
					Cryp.param = st;
					Cryp.FileX();
				}
			}
			if (st == "")
			{
				if (Common.selectFile == "")
				{
					if (Cryp.fileX != "") textBoxFileX.Text = Cryp.fileX;
				}
				else
				{
					textBoxFileX.Text = Common.selectFile;
				}
			}
			DisplayFileX();
			RunForm.FocusBothUs();
			textBoxFileX.Focus();
			textBoxFileX.SelectionStart = textBoxFileX.Text.Length;
		}

		private void buttonInitC_Click(object sender, EventArgs e)
		{
			Cryp.InitC();
			DisplayCryCon();
			RunForm.FocusBothUs();
			textBoxKeyIn.Focus();
			textBoxKeyIn.SelectionStart = textBoxKeyIn.Text.Length;
		}

		private void buttonEncode_Click(object sender, EventArgs e)
		{
			Cryp.Encode();
			RunForm.FocusBothUs();
			buttonEncode.Focus();
		}

		private void buttonDecode_Click(object sender, EventArgs e)
		{
			Cryp.Decode();
			RunForm.FocusBothUs();
			buttonDecode.Focus();
		}

		private void buttonExecute_Click(object sender, EventArgs e)
		{
			Calc.CalReadCode(Cryp.fileX);
			Common.running = false;
			RunForm.FocusBothUs();
			buttonExecute.Focus();
		}

		private void textBoxFileC_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in FileC box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonFileC.Enabled) buttonFileC_Click();
			}
		}

		private void textBoxFileC_TextChanged(object sender, EventArgs e)
		// process input of name of FileC
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxFileC.Text = textBoxFileC.Text.TrimStart(' '); // remove leading spaces
			st = textBoxFileC.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonFileC.Enabled = true;
				return;
			}
		}

		private void textBoxFileE_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in FileE box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonFileE.Enabled) buttonFileE_Click();
			}
		}

		private void textBoxFileE_TextChanged(object sender, EventArgs e)
		// process input of name of FileE
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxFileE.Text = textBoxFileE.Text.TrimStart(' '); // remove leading spaces
			st = textBoxFileE.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonFileE.Enabled = true;
				return;
			}
		}

		private void textBoxFileD_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in FileD box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonFileD.Enabled) buttonFileD_Click();
			}
		}

		private void textBoxFileD_TextChanged(object sender, EventArgs e)
		// process input of name of FileD
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxFileD.Text = textBoxFileD.Text.TrimStart(' '); // remove leading spaces
			st = textBoxFileD.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonFileD.Enabled = true;
				return;
			}
		}

		private void textBoxFileK_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in FileK box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonFileK.Enabled) buttonFileK_Click();
			}
		}

		private void textBoxFileK_TextChanged(object sender, EventArgs e)
		// process input of name of FileK
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxFileK.Text = textBoxFileK.Text.TrimStart(' '); // remove leading spaces
			st = textBoxFileK.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonFileK.Enabled = true;
				return;
			}
		}

		private void textBoxFileX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in FileX box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonFileX.Enabled) buttonFileX_Click();
			}
		}

		private void textBoxFileX_TextChanged(object sender, EventArgs e)
		// process input of name of FileX
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxFileX.Text = textBoxFileX.Text.TrimStart(' '); // remove leading spaces
			st = textBoxFileX.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonFileX.Enabled = true;
				return;
			}
		}
	}
}
